#include "../includes/recherche.h"
#include "../includes/structures.h"

void	fusionMaillonDevis(ListeDevis R, ListeDevis S, ListeDevis *T)
{
	ListeDevis	pT;

	*T = NULL;
	pT = *T;
	while (R && S) 
	{
		if (strcmp(R->dev.nomE, S->dev.nomE) < 0) 
		{
			if (!*T) 
			{
				*T = (ListeDevis)malloc(sizeof(MaillonDevis));
				pT = *T;
			}
			else
			{
				pT->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
				pT = pT->suiv;
			}
			pT->dev = R->dev;
			R = R->suiv;
		}
		else
		{
			if (!*T)
			{
				*T = (ListeDevis)malloc(sizeof(MaillonDevis));
				pT = *T;
			}
			else
			{
				pT->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
				pT = pT->suiv;
			}
			pT->dev = S->dev;
			S = S->suiv;
		}
		pT->suiv = NULL;
	}
	while (R)
	{
		if (!*T)
		{
			*T = (ListeDevis)malloc(sizeof(MaillonDevis));
			pT = *T;
		}
		else
		{
			pT->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
			pT = pT->suiv;
		}
		pT->dev = R->dev;
		R = R->suiv;
		pT->suiv = NULL;
	}
	while (S)
	{
		if (!*T)
		{
			*T = (ListeDevis)malloc(sizeof(MaillonDevis));
			pT = *T;
		}
		else
		{
			pT->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
			pT = pT->suiv;
		}
		pT->dev = S->dev;
		S = S->suiv;
		pT->suiv = NULL;
	}
}

void	freeListeDevis(ListeDevis *ldevis)
{
	ListeDevis pos;
	ListeDevis suiv;

	pos = *ldevis;
	while (pos) {
		suiv = pos->suiv;
		free(pos);
		pos = suiv;
	}
	*ldevis = NULL;
}

void	triFusionListeDevis(ListeDevis *ldevis) {
	ListeDevis	p;
	ListeDevis	q;

	p = *ldevis;
	q = p->suiv;
	if (!q)
		return;
/*
 la boucle qui suit cherche le milieu de la liste chainee
 ca rend le code plus complexe
 Pour une derniere version, il faudra la virer et la remplacer par une variable comme dans les versions precedentes du code 
*/
	while (q && q->suiv) // while q-suiv fonctionnerai car q existe forcément si q-suiv aussi ?
	{
		p = p->suiv;
		q = q->suiv->suiv;
	}
	q = p->suiv;
	p->suiv = NULL;
	triFusionListeDevis(ldevis);
	triFusionListeDevis(&q);
	fusionMaillonDevis(*ldevis, q, ldevis);
}

/*---------------------------------------------------------------------*/
/*
int	main(void)
{
	Offre offre1 = {"Travaux1", NULL};
	offre1.ldevis = (ListeDevis)malloc(sizeof(MaillonDevis));
	offre1.ldevis->dev = (Devis){"Devis6", "Adresse1", 100, 5};
	offre1.ldevis->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
	offre1.ldevis->suiv->dev = (Devis){"Devis3", "Adresse3", 80, 3};
	offre1.ldevis->suiv->suiv = NULL;

	Offre offre2 = {"Travaux2", NULL};
	offre2.ldevis = (ListeDevis)malloc(sizeof(MaillonDevis));
	offre2.ldevis->dev = (Devis){"Devis2", "Adresse2", 120, 7};
	offre2.ldevis->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
	offre2.ldevis->suiv->dev = (Devis){"Devis4", "Adresse4", 90, 4};
	offre2.ldevis->suiv->suiv = NULL;

	printf("Avant le tri : \n");
	afficherOffre(&offre1);
	afficherOffre(&offre2);

	triFusionListeDevis(&offre1.ldevis);

	printf("\nApres le tri : \n");
	afficherOffre(&offre1);
	afficherOffre(&offre2);

	freeListeDevis(&offre1.ldevis);
	freeListeDevis(&offre2.ldevis);
	return (0);
}
*/
